<?php
/**
 * BSeller - B2W Companhia Digital
 *
 * DISCLAIMER
 *
 * Do not edit this file if you want to update this module for future new versions.
 *
 * @copyright     Copyright (c) 2017 B2W Companhia Digital. (http://www.bseller.com.br/)
 * Access https://ajuda.skyhub.com.br/hc/pt-br/requests/new for questions and other requests.
 */

namespace B2W\SkyHub\Contract\Entity\Order;


/**
 * Interface ItemEntityInterface
 * @package B2W\SkyHub\Contract\Entity\Order
 */
interface ItemEntityInterface
{
    /**
     * @return string
     */
    public function getId();

    /**
     * @param $id
     * @return string
     */
    public function setId($id);

    /**
     * @return mixed
     */
    public function getOrderId();

    /**
     * @param $id
     * @return mixed
     */
    public function setOrderId($id);

    /**
     * @return \B2W\SkyHub\Contract\Entity\ProductEntityInterface
     */
    public function getProduct();

    /**
     * @param \B2W\SkyHub\Contract\Entity\ProductEntityInterface $product
     */
    public function setProduct(\B2W\SkyHub\Contract\Entity\ProductEntityInterface $product);

    /**
     * @return string
     */
    public function getName();

    /**
     * @param $name
     * @return string
     */
    public function setName($name);

    /**
     * @return int
     */
    public function getQty();

    /**
     * @param $qty
     * @return int
     */
    public function setQty($qty);

    /**
     * @return float
     */
    public function getOriginalPrice();

    /**
     * @param $originalPrice
     * @return float
     */
    public function setOriginalPrice($originalPrice);

    /**
     * @return float
     */
    public function getSpecialPrice();

    /**
     * @param $specialPrice
     * @return float
     */
    public function setSpecialPrice($specialPrice);

    /**
     * @return float
     */
    public function getShippingCost();

    /**
     * @param $shippingCost
     * @return float
     */
    public function setShippingCost($shippingCost);

    /**
     * @return string
     */
    public function getOrderItemType();

    /**
     * @param string $orderItemType
     */
    public function setOrderItemType($orderItemType);

    /**
     * @return mixed
     */
    public function getMeta();

    /**
     * @param $meta
     * @return mixed
     */
    public function setMeta($meta);

    /**
     * @param $key
     * @param $value
     * @return mixed
     */
    public function addMeta($key, $value);

    /**
     * @return mixed
     */
    public function save();
}
