<?php
/**
 * BSeller - B2W Companhia Digital
 *
 * DISCLAIMER
 *
 * Do not edit this file if you want to update this module for future new versions.
 *
 * @copyright     Copyright (c) 2017 B2W Companhia Digital. (http://www.bseller.com.br/)
 * Access https://ajuda.skyhub.com.br/hc/pt-br/requests/new for questions and other requests.
 */

namespace B2W\SkyHub\Contract\Entity\Order;

use B2W\SkyHub\Contract\Entity\Order\Payment\SefazEntityInterface;

/**
 * Interface PaymentEntityInterface
 * @package B2W\SkyHub\Contract\Entity\Order
 */
interface PaymentEntityInterface
{
    /**
     * @return float
     */
    public function getValue();

    /**
     * @param $value
     * @return float
     */
    public function setValue($value);

    /**
     * @return \DateTime
     */
    public function getTransactionDate();

    /**
     * @param $transactionDate
     * @return \DateTime
     */
    public function setTransactionDate($transactionDate);

    /**
     * @return string
     */
    public function getStatus();

    /**
     * @param $status
     * @return string
     */
    public function setStatus($status);

    /**
     * @return SefazEntityInterface
     */
    public function getSefaz();

    /**
     * @param $sefaz
     * @return SefazEntityInterface
     */
    public function setSefaz(SefazEntityInterface $sefaz);

    /**
     * @return string
     */
    public function getParcels();

    /**
     * @param $parcels
     * @return string
     */
    public function setParcels($parcels);

    /**
     * @return string
     */
    public function getMethod();

    /**
     * @param $method
     * @return string
     */
    public function setMethod($method);

    /**
     * @return string
     */
    public function getDescription();

    /**
     * @param $description
     * @return string
     */
    public function setDescription($description);

    /**
     * @return string
     */
    public function getCardIssuer();

    /**
     * @param $cardIssuer
     * @return string
     */
    public function setCardIssuer($cardIssuer);

    /**
     * @return string
     */
    public function getAutorizationId();

    /**
     * @param $autorizationId
     * @return string
     */
    public function setAutorizationId($autorizationId);
}
