<?php

/**
 * BSeller - B2W Companhia Digital
 *
 * DISCLAIMER
 *
 * Do not edit this file if you want to update this module for future new versions.
 *
 * @copyright     Copyright (c) 2020 B2W Companhia Digital. (http://www.bseller.com.br/)
 * Access https://ajuda.skyhub.com.br/hc/pt-br/requests/new for questions and other requests.
 */

namespace B2W\SkyHub\Helper\Catalog\Product;

use B2W\SkyHub\Model\Entity\ProductEntity;
use B2W\SkyHub\Model\Repository\OrderDbRepository;
use B2W\SkyHub\Model\Entity\SettingsApiEntity;

class Stock
{
    /**
     * Get qtd stock
     *
     * @param int $qtdStock
     * @param int $productId
     *
     * @return int
     */
    public function getQtdStock($qtdStock, $productId)
    {
        if ($qtdStock <= 0 || $qtdStock == null) {
            $stockStatus = get_metadata('post', $productId, '_stock_status');
            if ($stockStatus[0] == OrderDbRepository::INSTOCK) {
                $settingsAPI = new SettingsApiEntity();
                $settingsAPI->map();
                $qtdStock = $settingsAPI->getQtyStockDefault();
            }
        }
        return $qtdStock;
    }
}