<?php
/**
 * BSeller - B2W Companhia Digital
 *
 * DISCLAIMER
 *
 * Do not edit this file if you want to update this module for future new versions.
 *
 * @copyright     Copyright (c) 2017 B2W Companhia Digital. (http://www.bseller.com.br/)
 * Access https://ajuda.skyhub.com.br/hc/pt-br/requests/new for questions and other requests.
 */

namespace B2W\SkyHub\Model\Entity\Product;

use B2W\SkyHub\Contract\Entity\Product\Attribute\OptionEntityInterface;
use B2W\SkyHub\Model\Entity\EntityAbstract;
use B2W\SkyHub\Model\Resource\Collection;

/**
 * Class AttributeEntity
 * @package B2W\SkyHub\Model\Entity\Product
 */
class AttributeEntity extends EntityAbstract implements \B2W\SkyHub\Contract\Entity\Product\AttributeEntityInterface
{
    /** @var int */
    protected $_id = null;

    /** @var string */
    protected $_code = null;

    /** @var string */
    protected $_label = null;

    /** @var Collection */
    protected $_options = null;

    /**
     * @return int|mixed
     */
    public function getId()
    {
        return $this->_id;
    }

    /**
     * @param $id
     * @return $this|mixed
     */
    public function setId($id)
    {
        $this->_id = $id;
        return $this;
    }

    /**
     * @return mixed|string
     */
    public function getCode()
    {
        return $this->_code;
    }

    /**
     * @param $code
     * @return $this|mixed
     */
    public function setCode($code)
    {
        $this->_code = $code;
        return $this;
    }

    /**
     * @return mixed|string
     */
    public function getLabel()
    {
        return $this->_label;
    }

    /**
     * @param $label
     * @return $this|mixed
     */
    public function setLabel($label)
    {
        $this->_label = $label;
        return $this;
    }

    /**
     * @return Collection
     */
    public function getOptions()
    {
        if (is_null($this->_options)) {
            $this->_options = new Collection();
        }

        return $this->_options;
    }

    /**
     * @param OptionEntityInterface $option
     * @return $this|mixed
     */
    public function addOption(OptionEntityInterface $option)
    {
        $this->getOptions()->addItem($option);
        return $this;
    }
}
