<?php
/**
 * BSeller - B2W Companhia Digital
 *
 * DISCLAIMER
 *
 * Do not edit this file if you want to update this module for future new versions.
 *
 * @copyright     Copyright (c) 2019 B2W Companhia Digital. (http://www.bseller.com.br/)
 * Access https://ajuda.skyhub.com.br/hc/pt-br/requests/new for questions and other requests.
 */

namespace B2W\SkyHub\Model\Entity;

use B2W\SkyHub\View\Admin\Admin;

class QueueEntity
{
    /**
     * @var Int
     */
    protected $id;

    /**
     * @var String
     */
    protected $createdAt;

    /**
     * @var String
     */
    protected $type;

    /**
     * @var String
    */
    protected $param;

    /**
     * @var String
    */
    protected $status;


    /**
     * Get the value of id
     *
     * @return  Int
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set the value of id
     *
     * @param  Int  $id
     *
     * @return  self
     */
    public function setId($id)
    {
        $this->id = $id;

        return $this;
    }

    /**
     * Get the value of createdAt
     *
     * @return  String
     */
    public function getCreatedAt()
    {
        return $this->createdAt;
    }

    /**
     * Set the value of createdAt
     *
     * @param  String  $createdAt
     *
     * @return  self
     */
    public function setCreatedAt($createdAt)
    {
        $this->createdAt = $createdAt;

        return $this;
    }

    /**
     * Get the value of type
     *
     * @return  String
     */
    public function getType()
    {
        return $this->type;
    }

    /**
     * Set the value of type
     *
     * @param  String  $type
     *
     * @return  self
     */
    public function setType($type)
    {
        $this->type = $type;

        return $this;
    }

    /**
     * Get the value of param
     *
     * @return  String
     */
    public function getParam()
    {
        $param = '';
        if ($this->type == 'product_update') {
            $param = __('Product', Admin::DOMAIN);
        } else {
            $param = __('Order', Admin::DOMAIN);
        }
        return "$param: {$this->param}";
    }

    /**
     * Set the value of param
     *
     * @param  String  $param
     *
     * @return  self
     */
    public function setParam($param)
    {
        $this->param = $param;

        return $this;
    }

    /**
     * Get the value of status
     *
     * @return  String
     */
    public function getStatus()
    {
        return $this->status;
    }

    /**
     * Set the value of status
     *
     * @param  String  $status
     *
     * @return  self
     */
    public function setStatus($status)
    {
        $this->status = ucfirst($status);

        return $this;
    }
}
