<?php
/**
 * BSeller - B2W Companhia Digital
 *
 * DISCLAIMER
 *
 * Do not edit this file if you want to update this module for future new versions.
 *
 * @copyright     Copyright (c) 2019 B2W Companhia Digital. (http://www.bseller.com.br/)
 * Access https://ajuda.skyhub.com.br/hc/pt-br/requests/new for questions and other requests.
 */

namespace B2W\SkyHub\Model\Queue\Worker;

/**
 * Class OrderUpdateWorker
 * @package B2W\SkyHub\Model\Queue\Worker
 */
class OrderUpdateWorker
{
    /**
     * @param $orderId
     * @return $this
     * @throws \B2W\SkyHub\Exception\Data\RepositoryNotFound
     */
    public function shipp($orderId)
    {
        $order = $this->_getOrder($orderId);
        if (!$order->getChannel()) {
            return $this;
        }
        return \App::apiRepository(\App::REPOSITORY_ORDER)->shipp($order);
    }

    /**
     * @param $orderId
     * @return $this
     * @throws \B2W\SkyHub\Exception\Data\RepositoryNotFound
     */
    public function invoice($orderId)
    {
        $order = $this->_getOrder($orderId);
        if (!$order->getChannel()) {
            return $this;
        }
        return \App::apiRepository(\App::REPOSITORY_ORDER)->invoiceApi($order);
    }

    /**
     * @param $orderId
     * @return $this
     * @throws \B2W\SkyHub\Exception\Data\RepositoryNotFound
     */
    public function delivery($orderId)
    {
        $order = $this->_getOrder($orderId);
        if (!$order->getChannel()) {
            return $this;
        }
        return \App::apiRepository(\App::REPOSITORY_ORDER)->delivery($order);
    }

    /**
     * @param $orderId
     * @return $this
     * @throws \B2W\SkyHub\Exception\Data\RepositoryNotFound
     */
    public function cancel($orderId)
    {
        $order = $this->_getOrder($orderId);
        if (!$order->getChannel()) {
            return $this;
        }
        return \App::apiRepository(\App::REPOSITORY_ORDER)->cancel($order);
    }

    /**
     * @param $orderId
     * @return mixed
     * @throws \B2W\SkyHub\Exception\Data\RepositoryNotFound
     */
    protected function _getOrder($orderId)
    {
        return \App::repository(\App::REPOSITORY_ORDER)->one($orderId);;
    }
}
