<?php
/**
 * BSeller - B2W Companhia Digital
 *
 * DISCLAIMER
 *
 * Do not edit this file if you want to update this module for future new versions.
 *
 * @copyright     Copyright (c) 2019 B2W Companhia Digital. (http://www.bseller.com.br/)
 * Access https://ajuda.skyhub.com.br/hc/pt-br/requests/new for questions and other requests.
 */

namespace B2W\SkyHub\Model\Setup;

abstract class AbstractSetup
{
    /**
     * Install module
     *
     * @return $this
     */
    abstract public function install();

    abstract public function getTable();

    /**
     * Drop table if module is desactive
     * @return $this
     */
    public function uninstall()
    {
        global $wpdb;

        $tableName      = $wpdb->prefix . $this->getTable();

        $sql = "DROP TABLE IF EXISTS $tableName";

        $wpdb->query($sql);

        return $this;
    }
}
