<?php
/**
 * BSeller - B2W Companhia Digital
 *
 * DISCLAIMER
 *
 * Do not edit this file if you want to update this module for future new versions.
 *
 * @copyright     Copyright (c) 2019 B2W Companhia Digital. (http://www.bseller.com.br/)
 * Access https://ajuda.skyhub.com.br/hc/pt-br/requests/new for questions and other requests.
 */

namespace B2W\SkyHub\Model\SetupData;

use B2W\SkyHub\Model\Queue\Message\ProductUpdateMessage;
use B2W\SkyHub\Model\Repository\ProductDbRepository;

class Product extends AbstractSetupData
{
    /**
     * @return $this
     */
    public function install()
    {
        $product = new ProductDbRepository();
        $data = $product->find();

        if (!$data) {
            return;
        }

        foreach ($data->toArray() as $value) {
            $productIntegrated = get_metadata('post', $value['_id'], '_skyhub_product_integrated');
            if ($productIntegrated) {
                continue;
            }
            $message = new ProductUpdateMessage((String)$value['_id']);
            \App::repository(\App::REPOSITORY_QUEUE)->add($message);
        }
    }
}