<?php
/**
 * BSeller - B2W Companhia Digital
 *
 * DISCLAIMER
 *
 * Do not edit this file if you want to update this module for future new versions.
 *
 * @copyright     Copyright (c) 2017 B2W Companhia Digital. (http://www.bseller.com.br/)
 * Access https://ajuda.skyhub.com.br/hc/pt-br/requests/new for questions and other requests.
 */

namespace B2W\SkyHub\Model\Transformer\Order\Misc;

use B2W\SkyHub\Model\Transformer\EntityToDbAbstract;

/**
 * Class PostTitle
 * @package B2W\SkyHub\Model\Transformer\Order\Misc
 */
/** @method \B2W\SkyHub\Model\Entity\OrderEntity getEntity() */
class AddressIndex extends EntityToDbAbstract
{
    /**
     * @var array
     */
    protected $_fields = array(
        'street',
        'number',
        'neighborhood',
        'city',
        'state',
        'postcode',
        'country',
        'email',
        'phone',
        'secondary_phone'
    );

    /**
     * @return mixed|null
     */
    protected function _getMapInstance()
    {
        return null;
    }

    /**
     * @return EntityToDbAbstract|string
     * @throws \B2W\SkyHub\Exception\Data\RepositoryNotFound
     * @throws \B2W\SkyHub\Exception\Helper\HelperNotFound
     */
    public function convert()
    {
        $entity = $this->_attribute->getWordpress() == '_billing_address_index'
            ? $this->getEntity()->getBillingAddress()
            : $this->getEntity()->getShippingAddress();

        $result = array();
        $result[] = $this->getEntity()->getCustomer()->getName();
        $result[] = $this->getEntity()->getCustomer()->getEmail();

        foreach ($this->_fields as $field) {
            $method = \App::helper('app')->getGetterMethodName($entity, $field);
            if (!$method) {
                continue;
            }
            $result[] = $entity->$method();
        }

        return implode(' ', $result);
    }
}
