<?php
/**
 * BSeller - B2W Companhia Digital
 *
 * DISCLAIMER
 *
 * Do not edit this file if you want to update this module for future new versions.
 *
 * @copyright     Copyright (c) 2017 B2W Companhia Digital. (http://www.bseller.com.br/)
 * Access https://ajuda.skyhub.com.br/hc/pt-br/requests/new for questions and other requests.
 */

namespace B2W\SkyHub\View\Admin\Attribute;

use B2W\SkyHub\Model\Map\MapAttribute;
use B2W\SkyHub\Model\Map\MapAbstract;
use B2W\SkyHub\View\Admin\ViewAbstract;

/**
 * Class EditAbstract
 * @package B2W\SkyHub\View\Admin\Attribute
 */
abstract class EditAbstract extends ViewAbstract
{
    /**
     * @var string
     */
    protected $_template    = 'admin/attribute/edit.php';
    /**
     * @var null
     */
    protected $_attribute   = null;
    /**
     * @var null
     */
    protected $_config      = null;
    /**
     * @var null
     */
    protected $_map         = null;
    /**
     * @var string
     */
    protected $_redirect    = '';

    /**
     * @return null
     */
    public function getAttribute()
    {
        if (is_null($this->_attribute)) {
            $this->_loadAttribute();
        }

        return $this->_attribute;
    }

    /**
     * @return MapAbstract
     */
    protected function _getMapInstance()
    {
        if (is_null($this->_map)) {
            $this->_map = $this->_loadMapInstance();
        }

        return $this->_map;
    }

    /**
     * @return MapAbstract
     */
    abstract protected function _loadMapInstance();

    /**
     * @return $this
     */
    private function _loadAttribute()
    {
        $code = isset($_GET['attribute']) ? $_GET['attribute'] : null;

        foreach ($this->_getMapInstance()->map() as $attribute) {
            if ($attribute->getSkyhub() == $code) {
                $this->_attribute = $attribute;
                break;
            }
        }

        return $this;
    }

    /**
     * @return string
     * @throws \Exception
     */
    public function getEntity()
    {
        if (empty($this->_entity)) {
            throw new \B2W\SkyHub\Exception\Exception('Entity must be set');
        }

        return $this->_entity;
    }

    /**
     * @param $attr
     * @param $value
     * @return bool
     */
    public function validate($attr, $value)
    {
        return true;
    }

    /**
     * @param $value
     * @return mixed
     */
    abstract public function renderField(MapAttribute $value);
}
