<?php
/**
 * BSeller - B2W Companhia Digital
 *
 * DISCLAIMER
 *
 * Do not edit this file if you want to update this module for future new versions.
 *
 * @copyright     Copyright (c) 2017 B2W Companhia Digital. (http://www.bseller.com.br/)
 * Access https://ajuda.skyhub.com.br/hc/pt-br/requests/new for questions and other requests.
 */

namespace B2W\SkyHub\View\Admin\Form;

use B2W\SkyHub\View\Admin\ViewAbstract;

/**
 * Class FormAbstract
 * @package B2W\SkyHub\View\Admin\Form
 */
abstract class FormAbstract extends ViewAbstract
{
    /**
     * @var string
     */
    protected $_template  = 'admin/form/index.php';
    /**
     * @var array
     */
    protected $_fieldsets = array();

    /**
     * @return mixed
     */
    abstract protected function _prepareForm();

    /**
     * @return ViewAbstract|string
     */
    public function render()
    {
        $this->_prepareForm();
        return parent::render();
    }

    /**
     * @param $name
     * @param string $title
     * @return Fieldset
     */
    protected function _addFieldset($name, $title = '')
    {
        $fieldset = new Fieldset();
        $fieldset->setName($name);
        $fieldset->setTitle($title);

        $this->_fieldsets[$fieldset->getName()] = $fieldset;

        return $fieldset;
    }

    /**
     * @return array
     */
    public function getFieldsets()
    {
        return $this->_fieldsets;
    }
}
