<?php

/**
 * BSeller - B2W Companhia Digital
 *
 * DISCLAIMER
 *
 * Do not edit this file if you want to update this module for future new versions.
 *
 * @copyright     Copyright (c) 2017 B2W Companhia Digital. (http://www.bseller.com.br/)
 * Access https://ajuda.skyhub.com.br/hc/pt-br/requests/new for questions and other requests.
 */

namespace B2W\SkyHub\View;

use B2W\SkyHub\Helper\MessageErros;
/**
 * Class Template
 * @package B2W\SkyHub\View
 */
class Template
{
    /**
     * @var null
     */
    protected $_template = null;

    /**
     * @param $template
     * @return $this
     */
    public function setTemplate($template)
    {
        $this->_template = $template;
        return $this;
    }

    /**
     * @return $this|string
     */
    public function render()
    {
        if (empty($this->_template)) {
            return '';
        }

        $html = '';
        $file = \App::getBaseDir() . DS . 'view' . DS . $this->_template;

        if (file_exists($file)) {

            ob_start();
            include $file;

            $html = ob_get_clean();
        }

        $messageErros = new MessageErros();
        echo $messageErros->getMessageErrors();
        echo $html;

        return $this;
    }
}
