<?php

/**
 * B2W Digital - Companhia Digital
 *
 * Do not edit this file if you want to update this SDK for future new versions.
 * For support please contact the e-mail bellow:
 *
 * sdk@e-smart.com.br
 *
 * @category  SkuHub
 * @package   SkuHub
 *
 * @copyright Copyright (c) 2021 B2W Digital - BSeller Platform. (http://www.bseller.com.br).
 */

namespace SkyHub\Api\DataTransformer\Sales\Order;

use SkyHub\Api\DataTransformer\DataTransformerAbstract;

/**
 * B2WDirectInvoiced class
 */
class B2WDirectInvoiced extends DataTransformerAbstract
{
    /**
     * B2WDirectInvoiced constructor
     *
     * @param string $volumeQty
     * @param string $issueDate
     * @param string $pathFile
     * @param string $fileName
     * @param string $status
     */
    public function __construct(
        $volumeQty,
        $issueDate,
        $pathFile,
        $fileName,
        $status
    ) {
        $param = [
            'status' => $status,
            'volume_qty' => $volumeQty,
            'issue_date' => $issueDate
        ];

        $this->setOutputData($param);

        parent::__construct();
    }

    /**
     * Open de file xml and validate file
     *
     * @param string $pathFile
     * @return void
     */
    public function openFile($pathFile, $fileName)
    {
        $info = pathinfo($pathFile);
        if (!isset($info['extension'])) {
           $info = pathinfo($fileName);
        }

        if (!isset($info['extension'])) {
            $info['extension'] = '';
        }

        $extension = strtolower($info['extension']);
        
        if ($extension !== 'xml') {
            throw new \Exception('File invalid.');
        }

        if (!is_file($pathFile)) {
            throw new \Exception("File don't exist.");
        }

        return fopen($pathFile, 'r');
    }
}
