<?php
/**
 * B2W Digital - Companhia Digital
 *
 * Do not edit this file if you want to update this SDK for future new versions.
 * For support please contact the e-mail bellow:
 *
 * sdk@e-smart.com.br
 *
 * @category  SkuHub
 * @package   SkuHub
 *
 * @copyright Copyright (c) 2018 B2W Digital - BSeller Platform. (http://www.bseller.com.br).
 */

namespace SkyHub\Api\DataTransformer\Sales\Order;

use SkyHub\Api\DataTransformer\DataTransformerAbstract;

class Invoice extends DataTransformerAbstract
{

    /**
     * Attribute constructor.
     *
     * @param string $status
     * @param string $invoiceKey
     */
    public function __construct($status, $invoiceKey)
    {
        $param = [
            'invoice' => [
                'key' => $invoiceKey
            ]
        ];

        if ($status && is_string($status)) {
            $param['status'] = $status;
        }

        $this->setOutputData($param);

        parent::__construct();
    }
}
