<?php
/**
 * B2W Digital - Companhia Digital
 *
 * Do not edit this file if you want to update this SDK for future new versions.
 * For support please contact the e-mail bellow:
 *
 * sdk@e-smart.com.br
 *
 * @category  SkyHub
 * @package   SkyHub
 *
 * @copyright Copyright (c) 2018 B2W Digital - BSeller Platform. (http://www.bseller.com.br).
 *
 * @author    Bruno Gemelli <bruno.gemelli@e-smart.com.br>
 */

namespace SkyHub\Api\Service;

use SkyHub\Api\Log\TypeInterface\ResponsePdf;

class ServicePdf extends ServiceDefault
{
    
    /**
     * Service constructor.
     *
     * @param string $baseUri
     * @param array  $headers
     * @param array  $options
     */
    public function __construct($baseUri, array $headers = [], array $options = [], $log = true)
    {
        $headers['Accept']       = 'application/pdf';
        $headers['Content-Type'] = 'application/json';

        $options['stream']       = true;

        parent::__construct($baseUri, $headers, $options, $log);
    }
    
    
    /**
     * @param array $bodyData
     * @param array $options
     *
     * @return array
     */
    protected function prepareRequestBody($bodyData, array &$options = [])
    {
        $options['json'] = $bodyData;
        return $options;
    }


    /**
     * @return \SkyHub\Api\Log\TypeInterface\ResponsePdf
     */
    protected function getLoggerResponse()
    {
        return new ResponsePdf($this->getRequestId());
    }
}
